
<template>
  <q-layout
    view="lHr Lpr lff"
    v-bind:class="[$q.dark.isActive ? 'fondo-layout-dark ' : 'fondo-layout ']"
  >
    <q-header
      v-bind:class="[
        $q.dark.isActive
          ? 'fondo-layout-dark text-black q-pt-sm q-pb-sm padding-no-mobil-header'
          : 'fondo-layout  text-black q-pt-sm q-pb-sm padding-no-mobil-header',
      ]"
    >
      <q-toolbar>
        <q-btn
          dense
          flat
          round
          icon="menu"
          :color="$q.dark.isActive ? 'white' : 'indigo'"
          @click="drawer = !drawer"
          class="q-mr-sm"
        />
        <q-space />
        <q-toggle
          v-model="dark"
          :color="$q.dark.isActive ? 'indigo' : 'white'"
          icon="mdi-lightbulb-on"
          size="lg"
        />
        <q-btn
          flat
          round
          icon="mdi-exit-to-app"
          :color="$q.dark.isActive ? 'white' : 'indigo'"
          @click="logout"
        />
      </q-toolbar>
    </q-header>

    <!--breakpoint es cuando determina en que dimensión ocultar el drawer-->
    <q-drawer
      v-model="drawer"
      show-if-above
      side="left"
      :width="280"
      :breakpoint="1300"
    >
      <q-scroll-area
        class="scroll-style-administrador letras-system tamano-letra-titulos-modulos-layout"
      >
        <!-- $q.cookies.get('_mdls_') -->
        <q-list padding v-if="modulesGlobal">
          <div v-for="(el, i) in modulesGlobal" :key="'modulo' + i">
            <template v-if="!el.parent && !el.slug">
              <q-expansion-item
                expand-separator
                :icon="el.icon"
                :label="el.name"
                group="somegroup"
              >
                <div
                  v-for="(el_hijos, i_hijos) in modulesGlobal"
                  :key="'modulo_hijos' + i_hijos"
                >
                  <template v-if="el_hijos.parent == el.id">
                    <q-item
                      clickable
                      v-ripple
                      :to="{ name: el_hijos.nameref }"
                      :active="
                        $route.name ==
                          el_hijos.nameref + '.' + el_hijos.q_subestados[0] ||
                        $route.name ==
                          el_hijos.nameref + '.' + el_hijos.q_subestados[1] ||
                        $route.name ==
                          el_hijos.nameref + '.' + el_hijos.q_subestados[2] ||
                        $route.name ==
                          el_hijos.nameref + '.' + el_hijos.q_subestados[3] ||
                        $route.name ==
                          el_hijos.nameref + '.' + el_hijos.q_subestados[4] ||
                        $route.name ==
                          el_hijos.nameref + '.' + el_hijos.q_subestados[5] ||
                        $route.name ==
                          el_hijos.nameref + '.' + el_hijos.q_subestados[6] ||
                        $route.name ==
                          el_hijos.nameref + '.' + el_hijos.q_subestados[7]
                      "
                      router
                      exact
                    >
                      <!--lo dejé hasta 7 para que abarque los necesarios, por el momento tengo 3, listar,registrar,editar"-->
                      <q-item-section avatar>
                        <q-icon :name="el_hijos.icon" />
                      </q-item-section>
                      <q-item-section>{{ el_hijos.name }} </q-item-section>
                    </q-item>
                  </template>
                </div>
              </q-expansion-item>
            </template>
            <template v-else-if="!el.parent && el.slug">
              <q-item
                clickable
                v-ripple
                :to="{ name: el.nameref }"
                router
                exact
              >
                <q-item-section avatar>
                  <q-icon :name="el.icon" />
                </q-item-section>
                <q-item-section>{{ el.name }}</q-item-section>
              </q-item>
            </template>
          </div>
        </q-list>
      </q-scroll-area>

      <!--flex flex-center-->
      <div class="absolute-top div-administrador-layout">
        <div class="items-center flex justify-center" style="height: 104px">
          <img class="logo" src="statics/images/media-logo.png" />
        </div>
        <q-separator></q-separator>
        <!--<q-separator></q-separator>-->
      </div>
    </q-drawer>

    <q-page-container>
      <div class="gt-xs">
        <Bread></Bread>
      </div>
      <q-page class="q-pl-lg q-pr-lg q-pt-lg q-pb-xl padding-no-mobil">
        <router-view />
      </q-page>
    </q-page-container>
  </q-layout>
</template>

<script>
import { Notify } from "quasar";
import Bread from "../../components/bread-crumb/index.vue";

export default {
  components: {
    Bread,
  },
  data() {
    return {
      apiUrl: process.env.BASE_URL_API,
      dark: this.$q.dark.isActive,
      drawer: false,
      image: "",
    };
  },
  computed: {
    modulesGlobal() {
      return this.$store.getters["user/modulesGetter"];
    },
  },
  watch: {
    dark: {
      immediate: true,
      deep: true,
      handler(newValue, oldValue) {
        this.$q.dark.toggle();
        if (newValue) {
          this.$q.dark.set(true);
        } else {
          this.$q.dark.set(false);
        }
      },
    },
  },
  methods: {
    logout() {
      this.$store
        .dispatch("user/logoutAction")
        .then((success) => {
          Notify.create({
            color: "positive",
            position: "bottom",
            message: "Sesión cerrada correctamente",
            icon: "check",
          });
        })
        .catch((e) => {
          if (e.response.status == 401) {
            Notify.create({
              color: "negative",
              position: "bottom",
              message: "Usuario no autenticado",
              icon: "report_problem",
            });
            this.$router.push("/login");
          } else if (e.response.status == 403) {
            this.$router.push("/login");
          }
        });
    },
  },
  created() {},
};
</script>

<style scoped>
/deep/ aside {
  box-shadow: 0 4px 24px 0 rgb(34 41 47 / 10%);
}

/deep/ header {
  z-index: 1000;
}
</style>